



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>更便捷的Android多渠道打包方式</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">更便捷的Android多渠道打包方式</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 18:38:34 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<blockquote><p>本文先回顾了以往流行的多渠道打包方式，随后引入的mcxiaoke的packer-ng-plugin项目，介绍该项目在实际应用（配合友盟统计）中如何解决更方便的Android多渠道打包问题</p></blockquote>
<ul><li>多渠道打包方案解析</li>
<li>实际应用集成</li></ul>
<h3>多渠道打包方案解析</h3>
<p>android应用市场多种多样，应用宝、小米市场、豌豆荚...为了监督每个市场我们的应用下载和推广情况，对发布在每个市场上的apk打上烙印是必须的一步，这就是多渠道apk的问题，“渠道”就是给apk打上的烙印。<br /><br />
同时友盟统计可以帮我们统计渠道数据（Channel），方便产品经理对数据分析后做下一步产品决策。</p>
<p>目前多渠道打包方式大致有：</p>
<ol><li>gradle自带的productFlavor方式，见我之前的<a href="http://www.cnblogs.com/soaringEveryday/p/5368540.html" rel="external nofollow noreferrer">博客</a></li>
<li>apktool重签名重打包</li>
<li>在apk文件中的META-INF文件夹中写入以渠道号命名的空文件方式（美团）</li></ol>
<p>第三种是比较快的方式，据说900多个渠道不到一分钟就能打完，<a href="http://tech.meituan.com/mt-apk-packaging.html" rel="external nofollow noreferrer">参考</a>。但是缺点也是有的，你需要维护一个python脚本，为每一种渠道写入一个以渠道名命名的空文件。</p>
<p>本文将介绍的packer-ng-plugin的思路其实是有点类似的，由于apk就是一个zip文件，zip文件尾部有一个部分可以作为zip文件的注释，正确修改这一部分不会对ZIP文件造成破坏，利用这个字段，我们可以添加一些自定义的数据，PackerNg项目就是在这里添加和读取渠道信息。同时提供了读取渠道信息的接口。</p>
<h3>实际应用集成</h3>
<p>修改项目gradle，加入</p>
<pre class="prettyprint linenums"><code>buildscript {<br />
    ......<br />
    dependencies{<br />
    // add packer-ng<br />
        classpath 'com.mcxiaoke.gradle:packer-ng:1.0.5'<br />
    }<br />
}<br />
</code></pre>
<p>修改moudle级别gradle，加入</p>
<pre class="prettyprint linenums"><code>apply plugin: 'packer' 

dependencies {<br />
    // add packer-helper<br />
    compile 'com.mcxiaoke.gradle:packer-helper:1.0.5'<br />
}<br />
</code></pre>
<blockquote><p>注意：packer-ng 和 packer-helper 的版本号需要保持一致</p></blockquote>
<p>在你的项目根目录中加入渠道列表文件，比如文件名是market.txt，内容是</p>
<pre class="prettyprint linenums"><code>YingYongBao<br />
XiaoMi<br />
WanDouJia<br />
Baidu<br />
Qihoo<br />
GooglePlay<br />
...<br />
</code></pre>
<p>就是每一行即一个渠道号</p>
<p>再在你的项目根目录加入一个bat脚本（windows），比如叫做<code>build.bat</code>，内容写上（即一个命令）</p>
<pre class="prettyprint linenums"><code>gradle -Pmarket=markets.txt clean apkRelease<br />
</code></pre>
<p>大功告成，以后每次打渠道包，只要进入你的根目录，双击这bat脚本，packer-ng-plugin就开始自动帮你根据market.txt构建每一个渠道包；或者直接在android studio的<code>Terminal</code>中执行build.bat亦可。</p>
<p>观察控制台的输出，packer-ng最终是为每一个渠道包的打制形成了一个个的gradle task：</p>
<pre class="prettyprint linenums"><code>...<br />
:app:apkRelease processed apk for XiaoMi (4)<br />
:app:apkRelease processed apk for WanDouJia (5)<br />
:app:apkRelease processed apk for Baidu (6)<br />
:app:apkRelease processed apk for Qihoo (7)<br />
:app:apkRelease processed apk for GooglePlay (8)<br />
:app:apkRelease all 8 apks saved to D:\workspace\shine\build\archives<br />
:app:apkRelease PackerNg: Market Packaging Successful!<br />
BUILD SUCCESSFUL<br />
Total time: 1 mins 23.269 secs<br />
</code></pre>
<p>根据这个输出，他一共生成了8个渠道包，所有的apk输出在了项目根目录的build/archives文件夹中</p>
<p>packer-ng-plugin也提供了一些自定义配置，比如输入的apk的命名方式，具体参考<a href="https://github.com/mcxiaoke/packer-ng-plugin#%E6%8F%92%E4%BB%B6%E9%85%8D%E7%BD%AE%E8%AF%B4%E6%98%8E%E5%8F%AF%E9%80%89" rel="external nofollow noreferrer">插件配置说明</a>，同时提供了java和python的命令行脚本，供集成到持续集成环境中，具体参考<a href="https://github.com/mcxiaoke/packer-ng-plugin#%E5%91%BD%E4%BB%A4%E8%A1%8C%E6%89%93%E5%8C%85%E8%84%9A%E6%9C%AC" rel="external nofollow noreferrer">命令行打包脚本</a>。</p>
<p>最后需要提的一点就是如何让<strong>友盟统计</strong>知道目前的apk是哪个渠道。首先你需要删除之前的productFlavor或者manifest的占位符的方式的代码，删除AndroidManifest中友盟的渠道Channel的META-Data的配置。<br /><br />
然后在app入口（Application）的onCreate中加入下列代码：</p>
<pre class="prettyprint linenums"><code>final String market = PackerNg.getMarket(this,&quot;defaul_channel);<br />
AnalyticsConfig.setChannel(market); //AnalyticsConfig是友盟的代码方式设置渠道类<br />
</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqlj6nx9.html">linux下的tcp连接超时</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gp2749.html">Dijkstra的双栈算术表达式的求值算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv0n2x8.html">LTE Air interface Channels-----http&colon;&sol;&sol;www&period;rfwireless-world&period;com&sol;Tutorials&sol;LTE-logical-transport-physical-channels&period;html</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv7yvyq.html">HTTP 错误 500&period;22 - Internal Server Error</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pez0d8.html">How to know if file is complete on the server using FTP</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8omyxeq.html">JS 面向对象 编程设计</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmomok9.html">【CentOs】开机启动与防火墙</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnok3z8.html">android adt自带eclipse无法设置ndk路径&lpar;找不到NDK配置&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm4nlz9.html">微信公共服务平台开发（&period;Net 的实现）10-------地理位置</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mvy5kq.html">winform程序开机自动启动代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z17o0n9.html">BZOJ 1491 &lbrack;NOI2007&rsqb;社交网络</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo4ox1q.html">Linq 查询与普通查询的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/950zlgz8.html">二分求最长上升子序列   二分LIS</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjxo6l8.html">JAVA爬虫实践（实践三：爬虫框架webMagic和csdnBlog爬虫）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp3xkr9.html">用Cocos2dx开发棋牌游戏的观点解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jj3m5q.html">python 安装 reportlab 报错 &OpenCurlyDoubleQuote;ImportError&colon; No module named reportlab&period;lib&rdquo;</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g1vpeq.html">gitee 使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rxrlj9.html">&period;net中ashx文件有什么用？功能有那些，一般用在什么情况下？</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjm34p8.html">&num;Leetcode&num; 725&period; Split Linked List in Parts</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ezv7k9.html">阅读日志： 微信小程序的风口只有一天？</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/r936dwr9.html">java&period;lang&period;NoClassDefFoundError：TagSupport</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rwyw4q.html">java中equals和&amp;quot&semi;&equals;&equals;&amp;quot&semi;的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdxdvv8.html">MDX函数（官方顺序，带示例）</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jxp00q.html">【hbase】&mdash;&mdash;HBase 写优化之 BulkLoad 实现数据快速入库</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kd5nr9.html">Linux服务器文件删除空间未释放的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1djx2q.html">Confluent介绍（二）--confluent platform quickstart</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwzrz3q.html">Hadoop环境常用命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv7rwyq.html">高性能MySQL笔记：第1章 MySQL架构</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwz43kq.html">使用ajaxfileupload&period;js上传文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1dd64q.html">单机搭建Android开发环境&lpar;四&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
